<?php

include_once('ExportOutput.php');

class PageExport extends Page
{
	function ExportList()
	{
		global $User;
	
		$Output = '<a href="?Action=ViewList">Všechny</a>';
		if($User->Licence(LICENCE_USER))
		{
			$Output .= ' <a href="?Action=ViewList&amp;Filter=Others">Ostatních</a>'.
					' <a href="?Action=ViewList&amp;Filter=My">Moje</a>';
		}
	
		if($User->Licence(LICENCE_USER))
			$Output .= '<br/><div style="text-align: center;"><a href="?Action=Create">Vytvořit nový export</a></div><br/>';
		
		$Filter = '';
		if(array_key_exists('Filter', $_GET))
		{
			if($_GET['Filter'] == 'My') $Filter = ' WHERE `Export`.`User` = '.$User->Id;
			if($_GET['Filter'] == 'Others') $Filter = ' WHERE `Export`.`User` != '.$User->Id;
		}
	
		$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM `Export` '.$Filter);
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$Output .= '<h3>Seznam exportů</h3>'.
				$PageList['Output'];
	
		$TableColumns = array(
				array('Name' => 'TimeCreate', 'Title' => 'Čas vytvoření'),
				array('Name' => 'UserName', 'Title' => 'Překladatel'),
				array('Name' => 'Title', 'Title' => 'Označení'),
				//  array('Name' => 'UserCount', 'Title' => 'Vybraných překladatelů'),
				//  array('Name' => 'GroupCount', 'Title' => 'Překladových skupin'),
				array('Name' => 'OutputType', 'Title' => 'Typ výstupu'),
				array('Name' => 'ClientVersion', 'Title' => 'Verze klienta'),
				array('Name' => 'UsedCount', 'Title' => 'Prohlédnutí výstupu'),
				array('Name' => '', 'Title' => 'Akce'),
		);
		$Order = GetOrderTableHeader($TableColumns, 'TimeCreate', 1);
		$Output .= '<table class="BaseTable">'.
				$Order['Output'];
	
		$DbResult = $this->System->Database->query('SELECT `User`.`Name` AS `UserName`, `Export`.`Id`, `Export`.`TimeCreate`, `Export`.`Title`, `Export`.`User`, `Export`.`UsedCount`, (SELECT Version FROM `ClientVersion` WHERE `ClientVersion`.`Id`=`Export`.`ClientVersion`) AS `ClientVersion`,(SELECT Name FROM `ExportOutputType` WHERE `ExportOutputType`.`Id`=`Export`.`OutputType`) AS `OutputType`, (SELECT COUNT(*) FROM `ExportGroup` WHERE `ExportGroup`.`Export`=`Export`.`Id`) AS `GroupCount`, (SELECT COUNT(*) FROM `ExportUser` WHERE `ExportUser`.`Export`=`Export`.`Id`) AS `UserCount` FROM `Export` LEFT JOIN `User` ON `User`.`ID`=`Export`.`User` '.$Filter.$Order['SQL'].$PageList['SQLLimit']);
		while($Export = $DbResult->fetch_assoc())
		{
			$Action = '<a href="?Action=View&amp;ExportId='.$Export['Id'].'&amp;Tab=0">Zobrazit</a> '.
			  '<a href="?Action=View&amp;ExportId='.$Export['Id'].'&amp;Tab=7">Exportovat</a>';
			if($Export['User'] == $User->Id) $Action .= ' <a href="?Action=Delete&amp;ExportId='.$Export['Id'].'" onclick="return confirmAction(\'Opravdu smazat položku?\');">Smazat</a>';
			$Output .= '<tr><td>'.HumanDate($Export['TimeCreate']).'</td>'.
					'<td><a href="'.$this->System->Link('/user.php?user='.$Export['User']).'">'.$Export['UserName'].'</a></td>'.
					'<td>'.$Export['Title'].'</td>'.
					'<td>'.$Export['OutputType'].'</td>'.
					'<td>'.$Export['ClientVersion'].'</td>'.
					'<td>'.$Export['UsedCount'].'</td>'.
					'<td>'.$Action.'</td></tr>';
		}
		$Output .= '</table>'.
				$PageList['Output'];
	
		return($Output);
	}
	
	function ExportCreate()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM `Export` WHERE `User`='.$User->Id);
			$DbRow = $DbResult->fetch_row();
			if($DbRow[0] < $this->System->Config['MaxExportPerUser'])
			{
				$Output = '<form action="?Action=CreateFinish" method="post">'.
						'<fieldset><legend>Vytvoření nového exportu</legend>'.
						'<table><tr><td>Označení:</td><td><input type="text" name="Title" /></td></tr>'.
						'<tr><td>Popis:</td><td><textarea name="Description" cols="54" rows="10"></textarea></td></tr>'.
						'<tr><td colspan="2"><input type="submit" value="Vytvořit" /></td></tr>'.
						'</table></fieldset></form>';
			} else $Output = ShowMessage('Nemůžete vytvářet další export. Max. počet na uživatele je '.$this->System->Config['MaxExportPerUser'].'.', MESSAGE_CRITICAL);
		} else $Output = ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function ExportCreateFinish()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			if(array_key_exists('Title', $_POST) and array_key_exists('Description', $_POST))
			{
				$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM `Export` WHERE `User`='.$User->Id);
				$DbRow = $DbResult->fetch_row();
				if($DbRow[0] < $this->System->Config['MaxExportPerUser'])
				{
					$this->System->Database->query('INSERT INTO `Export` (`Title`, `User`, `TimeCreate`, `WithDiacritic`, `Description`) VALUES ("'.$_POST['Title'].'", '.$User->Id.', NOW(), 1, "'.$_POST['Description'].'")');
					$ExportId = $this->System->Database->insert_id;
					$Output = ShowMessage('Nový export vytvořen.<br/>Přímý odkaz na tento export: <a href="?Action=View&amp;ExportId='.$ExportId.'">zde</a>');
					WriteLog('Vytvořen nový export <a href="'.$this->System->Link('/export/?Action=View&amp;ExportId='.$ExportId).'">'.$ExportId.'</a>.', LOG_TYPE_EXPORT);
					$_GET['Filter'] = 'my';
					$this->ExportList();
				} else $Output = ShowMessage('Nemůžete vytvářet další export. Max. počet na uživatele je '.$this->System->Config['MaxExportPerUser'].'.', MESSAGE_CRITICAL);
			} else $Output = ShowMessage('Chybí údaje formuláře.', MESSAGE_CRITICAL);
		} else $Output = ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function ExportDelete()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE (`Id`='.($_GET['ExportId'] * 1).') AND (`User`='.$User->Id.')');
			if($DbResult->num_rows > 0)
			{
				$this->System->Database->query('DELETE FROM `ExportGroup` WHERE `Export`='.$_GET['ExportId']);
				$this->System->Database->query('DELETE FROM `ExportLanguage` WHERE `Export`='.$_GET['ExportId']);
				$this->System->Database->query('DELETE FROM `ExportTask` WHERE `Export`='.$_GET['ExportId']);
				$this->System->Database->query('DELETE FROM `ExportUser` WHERE `Export`='.$_GET['ExportId']);
				$this->System->Database->query('DELETE FROM `Export` WHERE `Id`='.$_GET['ExportId']);
				DeleteDirectory('../tmp/Export/'.$_GET['ExportId'].'/');
				$Output = ShowMessage('Export smazán.');
				$_GET['Filter'] = 'my';
				WriteLog('Smazán export '.$_GET['ExportId'], LOG_TYPE_EXPORT);
				$Output .= $this->ExportList();
			} else $Output = ShowMessage('Export nenalezen.', MESSAGE_CRITICAL);
		} else $Output = ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function ExportViewTranslators()
	{
		global $TranslationTree, $User;
	
		$Output = '';
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
		$Export = $DbResult->fetch_assoc();
		if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
		else $Editable = false;
	
		if(array_key_exists('Operation', $_POST))
		{
			if($_POST['Operation'] == 'Save')
			{
				//print_r($_POST);
				// Update user selection page
				foreach($_POST as $Index => $Value)
				{
					if(substr($Index, 0, 3) == 'seq')
					{
						$UserId = substr($Index, 3) * 1;
						if(array_key_exists('sel'.$UserId, $_POST)) $Selected = true;
						else $Selected = false;
						$Condition = ' WHERE `Export`='.$_GET['ExportId'].' AND `User`='.$UserId;
						$DbResult = $this->System->Database->query('SELECT * FROM `ExportUser` '.$Condition);
						if($DbResult->num_rows > 0)
						{
							if(!$Selected) $this->System->Database->query('DELETE FROM `ExportUser` '.$Condition);
							else $this->System->Database->query('UPDATE `ExportUser` SET `Sequence`='.$Value.$Condition);
						} else
						{
							if($Selected) $this->System->Database->query('INSERT INTO `ExportUser` (`Export`, `User`, `Sequence`) VALUES ('.$_GET['ExportId'].', '.$UserId.', '.$Value.')');
						}
					}
				}
	
				// Recalculate sequence number
				$this->System->Database->query('SET @I = 0');
				$this->System->Database->query('UPDATE `ExportUser` SET `Sequence` = (@I := @I + 1) WHERE `Export`='.$_GET['ExportId'].' ORDER BY `Sequence`;');
				$Output .= ShowMessage('Výběr uložen.');
			}
		}
	
		$TableColumns = array(
				array('Name' => 'Name', 'Title' => 'Jméno'),
				array('Name' => 'TranslatedCount', 'Title' => 'Překladů'),
				array('Name' => 'XP', 'Title' => 'Úroveň'),
				array('Name' => 'XP', 'Title' => 'Zkušenost'),
				array('Name' => '', 'Title' => 'Výběr'),
				array('Name' => 'Sequence2', 'Title' => 'Pořadí'),
		);
		$Order = GetOrderTableHeader($TableColumns, 'TranslatedCount', 1);
		if($Order['Column'] != 'Sequence2') $InitialOrder = ', '.substr($Order['SQL'], 10);
		else $InitialOrder = '';
	
		$Query = 'SELECT (@I := @I + 1) AS `Sequence2`, `TT`.* FROM (SELECT `ExportUser`.`Sequence`, `T`.`ID`, `T`.`TranslatedCount`, `T`.`Name`, `T`.`XP` FROM (SELECT `User`.`ID`, `User`.`Name`, `User`.`XP`, `TranslatedCount` FROM `User`) AS T';
		$Query .=' LEFT JOIN `ExportUser` ON `ExportUser`.`Export` = '.$_GET['ExportId'].' AND `ExportUser`.`User`=`T`.`ID`';
		$Query .=' WHERE `T`.`TranslatedCount` > 0 ORDER BY COALESCE(`ExportUser`.`Sequence`, 100000000)'.$InitialOrder.') AS `TT`';
	
		$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM ('.$Query.') AS `X`');
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$Output .= '<form name="Translators" action="?Action=View&amp;ExportId='.$_GET['ExportId'].'" method="post">'.
				'<h3>Překladatelé</h3>';
		if($Editable)
		{
			$Output .= '<input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/>'.
					'<input type="hidden" name="Operation" value="Save"/>'.
					' <span onclick="CheckAllCheckbox();">'.CheckBox('CheckAll', False, 'CheckAll').' Zatrhnout vše</span> '.
					'<br />'.
					'Zvolte ze seznamu uživatele, od kterých chcete načítat překlady a upravte jejich pořadí.<br />'.
					'Pořadí řádků je dáno číselnou hodnotou, kterou lze změnit na požadované pořadí. Řádky se stejným pořadovým číslem budou přečíslovány vzestupně.';
		}
	
		$Output .= $PageList['Output'].
		'<table class="BaseTable">'.
		$Order['Output'];
	
		$Query = 'SELECT * FROM ('.$Query.') AS `TX` '.$Order['SQL'].$PageList['SQLLimit'];
		$this->System->Database->query('SET @I = 0');
		$DbResult = $this->System->Database->query($Query);
		while($UserLine = $DbResult->fetch_assoc())
		{
			$XP = GetLevelMinMax($UserLine['XP']);
			$Checked = $UserLine['Sequence'] != '';
			$Selection = CheckBox('sel'.$UserLine['ID'], $Checked, '', 'CheckBox', !$Editable);
			$Sequence = '<input type="text" name="seq'.$UserLine['ID'].'" style="text-align: center; width: 40px;" value="'.$UserLine['Sequence2'].'"'.$DisabledInput[$Editable].'/>';
			$Output .= '<tr>'.
					'<td><a href="'.$this->System->Link('/TranslationList.php?user='.$UserLine['ID'].'&amp;state=2&amp;group=0').'" title="Zobrazit všechny jeho přeložené texty">'.$UserLine['Name'].'</a></td>'.
					'<td>'.$UserLine['TranslatedCount'].'</td>'.
					'<td>'.$XP['Level'].'</td>'.
					'<td>'.ProgressBar(150, round($XP['XP'] / $XP['MaxXP'] * 100, 2), $XP['XP'].' / '.$XP['MaxXP']).'</td>'.
					'<td>'.$Selection.'</td><td>'.$Sequence.'</td></tr>';
		}
		$Output .= '</table>'.
				'</form>'.
				$PageList['Output'];
		return($Output);
	}
	
	function ExportViewGeneral()
	{
		global $User;
	
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		$DisabledTextArea = array(false => ' readonly="yes"', true => '');
		$Output = '<h3>Obecná nastavení</h3>';
		$DbRows = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
		$Export = $DbRows->fetch_assoc();
		if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
		else $Editable = false;
	
		if(array_key_exists('Operation', $_POST))
			if($_POST['Operation'] == 'Save')  if($Editable and array_key_exists('Title', $_POST) and array_key_exists('Description', $_POST))
			{
				if(array_key_exists('WithDiacritic', $_POST)) $WithDiacritic = 1;
				else $WithDiacritic = 0;
				$this->System->Database->query('UPDATE `Export` SET `Title`="'.$_POST['Title'].'", `Description`="'.$_POST['Description'].'", `WithDiacritic`='.$WithDiacritic.' WHERE Id='.$Export['Id']);
				$Export['Title'] = $_POST['Title'];
				$Export['Description'] = $_POST['Description'];
				$Export['WithDiacritic'] = $WithDiacritic;
				$Output .= ShowMessage('Nastavení uloženo.');
			}
	
			if($Export['WithDiacritic'] == 1) $WithDiacritic = ' checked="checked"';
			else $WithDiacritic = '';
			$Output .= '<form action="?Action=View&amp;Tab=0&amp;ExportId='.$Export['Id'].'" method="post">'.
					'<table>';
			if($Editable)
			{
				$Output .= '<input type="hidden" name="Operation" value="Save"/>'.
						'<tr><td colspan="2"><input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/></td></tr>';
			}
			$Output .= '<tr><td>Označení:</td><td><input type="text" style="width: 400px" name="Title" value="'.$Export['Title'].'"'.$DisabledInput[$Editable].'/></td></tr>'.
					'<tr><td>Popis:</td><td><textarea name="Description" cols="54" rows="10"'.$DisabledTextArea[$Editable].'>'.$Export['Description'].'</textarea></td></tr>'.
					'<tr><td>Včetně háčků a čárek</td><td><input type="checkbox" name="WithDiacritic" '.$WithDiacritic.''.$DisabledInput[$Editable].'/></td></tr>'.
					'</table></form>';
			return($Output);
	}
	
	function ExportViewLanguages()
	{
		global $TranslationTree, $User;
	
		$Output = '';
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		$DbRows = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
		$Export = $DbRows->fetch_assoc();
		if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
		else $Editable = false;
	
		if(array_key_exists('Operation', $_POST))
		{
			if($_POST['Operation'] == 'Save')
			{
				//print_r($_POST);
				// Update user selection page
				foreach($_POST as $Index => $Value)
				{
					if(substr($Index, 0, 3) == 'seq')
					{
						$LanguageId = substr($Index, 3) * 1;
						if(array_key_exists('sel'.$LanguageId, $_POST)) $Selected = true;
						else $Selected = false;
						$Condition = ' WHERE Export='.$_GET['ExportId'].' AND `Language`='.$LanguageId;
						$DbResult = $this->System->Database->query('SELECT * FROM `ExportLanguage` '.$Condition);
						if($DbResult->num_rows > 0)
						{
							if(!$Selected) $this->System->Database->query('DELETE FROM `ExportLanguage` '.$Condition);
							else $this->System->Database->query('UPDATE `ExportLanguage` SET `Sequence`='.$Value.$Condition);
						} else
						{
							if($Selected) $this->System->Database->query('INSERT INTO `ExportLanguage` (`Export`, `Language`, `Sequence`) VALUES ('.$_GET['ExportId'].', '.$LanguageId.', '.$Value.')');
						}
					}
				}
	
				// Recalculate sequence number
				$this->System->Database->query('SET @I = 0');
				$this->System->Database->query('UPDATE `ExportLanguage` SET `Sequence` = (@I := @I + 1) WHERE `Export`='.$_GET['ExportId'].' ORDER BY `Sequence`;');
				$Output .= ShowMessage('Výběr uložen.');
			}
		}
	
		$Query = 'SELECT (@I := @I + 1) AS `Sequence2`, `Sequence`, `Language`.`Id`, `Name` FROM `Language`';
		$Query .=' LEFT JOIN `ExportLanguage` ON `ExportLanguage`.`Export` = '.$_GET['ExportId'].' AND `ExportLanguage`.`Language`=`Language`.`Id`';
		$Query .=' WHERE `Language`.`Enabled` = 1 ORDER BY COALESCE(`Sequence`, 100)';
	
		$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM ('.$Query.') AS X');
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$TableColumns = array(
				array('Name' => 'Name', 'Title' => 'Název'),
				array('Name' => '', 'Title' => 'Výběr'),
				array('Name' => 'Sequence2', 'Title' => 'Pořadí'),
		);
		$Order = GetOrderTableHeader($TableColumns, 'Sequence2');
		$Output .= '<form action="?Action=View&amp;ExportId='.$_GET['ExportId'].'" method="post">'.
				'<h3>Jazyky</h3>';
		if($Editable)
		{
			$Output .= '<input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/>'.
					'<input type="hidden" name="Operation" value="Save"/>'.
					'<br />'.
					'Zvolte ze seznamu dostupných jazyků, ze kterých chcete sestavit překlady a upravte jejich pořadí.<br />'.
					'Pořadí řádků je dáno číselnou hodnotou, kterou lze změnit na požadované pořadí. Řádky se stejným pořadovým číslem budou přečíslovány vzestupně.';
		}
	
		$Output .= $PageList['Output'].
		'<table class="BaseTable">'.
		$Order['Output'];
	
		$Query = 'SELECT * FROM ('.$Query.') AS TX '.$Order['SQL'].$PageList['SQLLimit'];
		$this->System->Database->query('SET @I = 0');
		$DbResult = $this->System->Database->query($Query);
		while($Langugage = $DbResult->fetch_assoc())
		{
			$Checked = $Langugage['Sequence'] != '';
			$Selection = CheckBox('sel'.$Langugage['Id'], $Checked, '', 'CheckBox', !$Editable);
			$Sequence = '<input type="text" name="seq'.$Langugage['Id'].'" style="text-align: center; width: 40px;" value="'.$Langugage['Sequence2'].'"'.$DisabledInput[$Editable].'/>';
			$Output .= '<tr>
			<td>'.$Langugage['Name'].'</a></td>
			<td>'.$Selection.'</td><td>'.$Sequence.'</td></tr>';
		}
		$Output .= '</table>'.
				'</form>'.
				$PageList['Output'];
		return($Output);
	}
	
	function ExportViewGroups()
	{
		global $TranslationTree, $User;
	
		$Output = '';
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		$DbRows = $this->System->Database->query('SELECT * FROM Export WHERE Id='.$_GET['ExportId']);
		$Export = $DbRows->fetch_assoc();
		if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
		else $Editable = false;
	
		if(array_key_exists('Operation', $_POST))
		{
			if($_POST['Operation'] == 'Save')
			{
				//print_r($_POST);
				// Update user selection page
				foreach($_POST as $Index => $Value)
				{
					if(substr($Index, 0, 3) == 'seq')
					{
						$GroupId = substr($Index, 3) * 1;
						if(array_key_exists('sel'.$GroupId, $_POST)) $Selected = true;
						else $Selected = false;
						$Condition = ' WHERE `Export`='.$_GET['ExportId'].' AND `Group`='.$GroupId;
						$DbResult = $this->System->Database->query('SELECT * FROM `ExportGroup` '.$Condition);
						if($DbResult->num_rows > 0)
						{
							if(!$Selected) $this->System->Database->query('DELETE FROM `ExportGroup` '.$Condition);
						} else
						{
							if($Selected) $this->System->Database->query('INSERT INTO `ExportGroup` (`Export`, `Group`) VALUES ('.$_GET['ExportId'].', '.$GroupId.')');
						}
					}
				}
				$Output .= ShowMessage('Výběr uložen.');
			}
		}
	
		$Query = 'SELECT `Group`.*, `ExportGroup`.`Id` AS `ExportGroupId` FROM `Group` LEFT JOIN `ExportGroup` ON `ExportGroup`.`Export`='.$_GET['ExportId'].' AND `Group`=`Group`.`Id`';
	
		$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM ('.$Query.') AS X');
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$TableColumns = array(
				array('Name' => 'Name', 'Title' => 'Jméno'),
				array('Name' => 'MangosTable', 'Title' => 'Tabulka MaNGOSu'),
				array('Name' => 'DBCFileName', 'Title' => 'DBC soubor'),
				array('Name' => 'LuaFileName', 'Title' => 'Lua soubor'),
				array('Name' => '', 'Title' => 'Výběr'),
		);
		$Order = GetOrderTableHeader($TableColumns, 'Name');
		$Output .= '<form action="?Action=View&amp;ExportId='.$_GET['ExportId'].'" method="post">'.
				'<h3>Překladové skupiny</h3>';
		if($Editable)
		{
			$Output .= '<input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/>'.
					'<input type="hidden" name="Operation" value="Save"/>'.
					' <span onclick="CheckAllCheckbox();">'.CheckBox('CheckAll', False, 'CheckAll').' Zatrhnout vše</span> '.
					'<br />'.
					'Zvolte ze překladových skupin, ze kterých chcete načítat překlady.<br />';
		}
	
		$Output .= $PageList['Output'].
		'<table class="BaseTable">'.
		$Order['Output'];
	
		$Query = 'SELECT * FROM ('.$Query.') AS TX '.$Order['SQL'].$PageList['SQLLimit'];
		$DbResult = $this->System->Database->query($Query);
		while($Group = $DbResult->fetch_assoc())
		{
			$Checked = $Group['ExportGroupId'] != '';
			$Selection = CheckBox('sel'.$Group['Id'], $Checked, '', 'CheckBox', !$Editable);
			$Output .= '<tr>'.
					'<td>'.$Group['Name'].'</td>'.
					'<td>'.$Group['MangosTable'].'</td>'.
					'<td>'.$Group['DBCFileName'].'</td>'.
					'<td>'.$Group['LuaFileName'].'</td>'.
					'<td>'.$Selection.'<input type="hidden" name="seq'.$Group['Id'].'"/></td></tr>';
		}
		$Output .= '</table>'.
				'</form>'.
				$PageList['Output'];
		return($Output);
	}
	
	function ExportViewOutputFormat()
	{
		global $User;
	
		$Output = '';
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		if(array_key_exists('ExportId', $_GET))
		{
			$DbRows = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
			if($DbRows->num_rows > 0)
			{
				$Export = $DbRows->fetch_assoc();
				if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
				else $Editable = false;
	
				if(array_key_exists('Operation', $_POST))
					if($_POST['Operation'] == 'Save')
					{
						if(array_key_exists('OutputType', $_POST) and ($_POST['OutputType'] * 1 > 0))
						{
						  $this->System->Database->query('UPDATE Export SET OutputType='.$_POST['OutputType'].' WHERE Id='.$_GET['ExportId']);
						  $Output .= ShowMessage('Výběr uložen.');
					  } else $Output .= ShowMessage('Nevybrán žádný formát', MESSAGE_CRITICAL);
					}
	
					$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
					$Export = $DbResult->fetch_assoc();
	
					$Output .= '<h3>Formát generovaného výstupu</h3>'.
							'<form action="?Action=View&amp;ExportId='.$_GET['ExportId'].'" method="post">';
					if($Editable)
					{
						$Output .= '<input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/>'.
								'<input type="hidden" name="Operation" value="Save"/>'.
								'<br />';
					}
					$DbResult = $this->System->Database->query('SELECT * FROM `ExportOutputType` ORDER BY `Name`');
					while($ExportFormat = $DbResult->fetch_assoc())
					{
						$Output .= RadioButton('OutputType', $ExportFormat['Id'], $Export['OutputType'] == $ExportFormat['Id'], '', !$Editable).' '.$ExportFormat['Name'].'<br/>';
					}
					$Output .= '</form>';
			} else $Output .= ShowMessage('Položka nenalezena.', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Nebylo zadáno Id.', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function ExportViewVersion()
	{
		global $User;
	
		$Output = '';
		$DisabledInput = array(false => ' disabled="disabled"', true => '');
		$DbRows = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
		$Export = $DbRows->fetch_assoc();
		if($User->Licence(LICENCE_USER) and ($User->Id == $Export['User'])) $Editable = true;
		else $Editable = false;
	
		if(array_key_exists('Operation', $_POST))
			if(($_POST['Operation'] == 'Save') and (array_key_exists('ClientVersion', $_POST)))
			{
				$this->System->Database->query('UPDATE `Export` SET `ClientVersion`='.$_POST['ClientVersion'].' WHERE `Id`='.$_GET['ExportId']);
				$Output .= ShowMessage('Výběr uložen.');
			}
	
			$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
			$Export = $DbResult->fetch_assoc();
	
			if($Export['OutputType'] == '') $Output .= ShowMessage('Nevybrán typ exportu', MESSAGE_CRITICAL);
			else {
				$Query = 'SELECT `ClientVersion`.* FROM `ExportVersion` LEFT JOIN `ClientVersion` ON `ClientVersion`.`Id`=`ExportVersion`.`ClientVersion` WHERE `ExportType`='.$Export['OutputType'];
	
				$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM ('.$Query.') AS `X`');
				$DbRow = $DbResult->fetch_row();
				$PageList = GetPageList($DbRow[0]);
	
				$TableColumns = array(
						array('Name' => 'Version', 'Title' => 'Verze'),
						array('Name' => 'BuildNumber', 'Title' => 'Sestavení'),
						array('Name' => 'ReleaseDate', 'Title' => 'Datum uvolnění'),
						array('Name' => 'Title', 'Title' => 'Titutek'),
						array('Name' => '', 'Title' => 'Výběr'),
				);
				$Order = GetOrderTableHeader($TableColumns, 'BuildNumber', 1);
				$Output .= '<form action="?Action=View&amp;ExportId='.$_GET['ExportId'].'" method="post">'.
						'<h3>Verze klienta</h3>';
	
				if($Editable)
				{
					$Output .= '<input type="submit" value="Uložit" '.$DisabledInput[$Editable].'/>'.
							'<input type="hidden" name="Operation" value="Save"/>'.
							'<br />'.
							'Vyberte pro jakou verzi herního klienta se budou texty exportovat.<br />';
				}
				$Output .= $PageList['Output'].
				'<table class="BaseTable">'.
				$Order['Output'];
	
				$Query = 'SELECT * FROM ('.$Query.') AS `TX` '.$Order['SQL'].$PageList['SQLLimit'];
				$DbResult = $this->System->Database->query($Query);
				while($Version = $DbResult->fetch_assoc())
				{
					$Output .= '<tr><td><a href="http://www.wowwiki.com/Patch_'.$Version['Version'].'">'.
							$Version['Version'].'</a></td><td>'.$Version['BuildNumber'].'</td><td>'.
							HumanDate($Version['ReleaseDate']).'</td><td>'.$Version['Title'].'</td><td>'.
							RadioButton('ClientVersion', $Version['Id'], $Export['ClientVersion'] == $Version['Id'], '', !$Editable
							).'</td></tr>';
	
				}
				$Output .= '</table>'.
						'</form>'.
						$PageList['Output'];
			}
			return($Output);
	}
	
	function ExportViewOutput()
	{
		$Output = '';
		$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
		$Export = $DbResult->fetch_assoc();
		if($Export['OutputType'] == '') $Output .= ShowMessage('Nevybrán typ exportu', MESSAGE_CRITICAL);
		else if($Export['ClientVersion'] == '') $Output .= ShowMessage('Export nemá vybránu verzi klienta', MESSAGE_CRITICAL);
		else {
			$DbResult = $this->System->Database->query('SELECT * FROM `ExportOutputType` WHERE `Id`='.$Export['OutputType']);
			if($DbResult->num_rows > 0)
			{
				$DbResult = $this->System->Database->query('SELECT * FROM `ExportVersion` WHERE (`ExportType`='.$Export['OutputType'].') AND (`ClientVersion`='.$Export['ClientVersion'].')');
				if($DbResult->num_rows > 0)
				{
					$this->System->Database->query('UPDATE `Export` SET `UsedCount` = `UsedCount` + 1 WHERE `Id`='.$Export['Id']);
					$Output = ExportOutput($Export['Id'], $Export['OutputType']);
				} else $Output = ShowMessage('Nebyla vybrána požadovaná verze klienta.', MESSAGE_CRITICAL);
			} else $Output = ShowMessage('Nebyl vybrán formát výstupu.', MESSAGE_CRITICAL);
		}
		return($Output);
	}
	
	function ExportViewStat()
	{
		$Export = new Export($this->System);
		$Export->Id = $_GET['ExportId'];
		$Export->Init();
		$Export->LoadFilters();
	
		if(($Export->Export['ClientVersion'] == '') or ($Export->ClientVersion['BuildNumber'] == ''))
			$Output = ShowMessage('Nebyla vybrána verze klienta', MESSAGE_CRITICAL);
		else {
			$GroupListQuery = 'SELECT `Group`.* FROM `Group` '.
					' JOIN `ExportGroup` ON (`ExportGroup`.`Export`='.$Export->Id.') AND (`ExportGroup`.`Group`=`Group`.`Id`)';
			$Query = '';
			$UnionItems = array();
			$DbResult = $this->System->Database->query($GroupListQuery);
			while($DbRow = $DbResult->fetch_assoc())
			{
				$UnionItems[] = 'SELECT (SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
						' SELECT `T`.* FROM `'.$DbRow['TablePrefix'].'` AS `T`'.
						' JOIN `ExportUser` ON (`ExportUser`.`User`=`T`.`User`) AND (`ExportUser`.`Export`='.$Export->Id.') '.
						' JOIN `ExportLanguage` ON (`ExportLanguage`.`Export`='.$Export->Id.')'.
						' WHERE (`Complete` = 1) AND (`VersionStart` <= '.$Export->ClientVersion['BuildNumber'].') AND (`VersionEnd` >= '.$Export->ClientVersion['BuildNumber'].')'.
						') AS `C1`) AS `Translated`, '.
						'(SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
						' SELECT `T`.* FROM `'.$DbRow['TablePrefix'].'` AS `T`'.
						' WHERE (`Language` = '.$this->System->Config['OriginalLanguage'].') AND (`VersionStart` <= '.$Export->ClientVersion['BuildNumber'].') AND (`VersionEnd` >= '.$Export->ClientVersion['BuildNumber'].')'.
						') AS `C2`) AS `Total`, "'.$DbRow['Name'].'" AS `Name`';
			}
			$Query = substr($Query, 0, - 6);
	
			$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM ('.$GroupListQuery.') AS `T`');
			$DbRow = $DbResult->fetch_row();
			$PageList = GetPageList($DbRow[0]);
			$Output = '<h3>Statistika dokončení vybraných skupin</h3>'.
				$PageList['Output'];
	
			$Output .= '<table class="BaseTable">';
			$TableColumns = array(
				array('Name' => 'Name', 'Title' => 'Jméno'),
				array('Name' => 'Translated', 'Title' => 'Přeložených'),
				array('Name' => 'Total', 'Title' => 'Anglických'),
				array('Name' => 'Percent', 'Title' => 'Procenta'),
			);
	
			$Order = GetOrderTableHeader($TableColumns, 'Name', 0);
			$Output .= $Order['Output'];
	
			$Translated = 0;
			$Total = 0;
			if(count($UnionItems) > 0)
			{
				$ID = $this->System->Database->query('SELECT *, ROUND(`Translated` / `Total` * 100, 2) AS `Percent` FROM ('.implode(' UNION ALL ', $UnionItems).') AS `C3` '.$Order['SQL'].$PageList['SQLLimit']);
				while($Group = $ID->fetch_assoc())
				{
					$Output .= '<tr><td>'.$Group['Name'].'</td><td>'.$Group['Translated'].'</td><td>'.$Group['Total'].'</td><td>'.ProgressBar(150, $Group['Percent']).'</td></tr>';
					$Translated += $Group['Translated'];
					$Total += $Group['Total'];
				}
			}
			if($Total > 0) $Percent = $Translated / $Total * 100;
			else $Percent = 100;
	
			$Output .= '<tr><td><strong>Celkem</strong></td><td><strong>'.$Translated.'</strong></td><td><strong>'.$Total.'</strong></td><td><strong>'.ProgressBar(150, round($Percent, 2)).'</strong></td></tr>';
			$Output .= '</table>';
		}
		return($Output);
	}
	
	function ExportView()
	{
		$Output = '';
		if(array_key_exists('ExportId', $_GET) and is_numeric($_GET['ExportId']))
		{
			$DbResult = $this->System->Database->query('SELECT * FROM `Export` WHERE `Id`='.$_GET['ExportId']);
			if($DbResult->num_rows > 0)
			{
				$Export = $DbResult->fetch_assoc();
	
				$DbResult = $this->System->Database->query('SELECT * FROM `User` WHERE `ID`='.$Export['User']);
				$UserLine = $DbResult->fetch_assoc();
				$Output .= 'Export <strong><a href="?Action=View&amp;Tab=6&amp;ExportId='.$Export['Id'].'">'.$_GET['ExportId'].'</a></strong> překladatele <strong>'.$UserLine['Name'].'</strong> s označením <strong>'.$Export['Title'].'</strong>';
				$Output .= ShowTabs(array('Obecné', 'Překladatelé', 'Překlady', 'Jazyky', 'Formát', 'Verze', 'Statistika', 'Výstup'));
				$Output .= '<div id="content">';
				if($_SESSION['Tab'] == 0) $Output .= $this->ExportViewGeneral();
				else if($_SESSION['Tab'] == 1) $Output .= $this->ExportViewTranslators();
				else if($_SESSION['Tab'] == 2) $Output .= $this->ExportViewGroups();
				else if($_SESSION['Tab'] == 3) $Output .= $this->ExportViewLanguages();
				else if($_SESSION['Tab'] == 4) $Output .= $this->ExportViewOutputFormat();
				else if($_SESSION['Tab'] == 5) $Output .= $this->ExportViewVersion();
				else if($_SESSION['Tab'] == 6) $Output .= $this->ExportViewStat();
				else if($_SESSION['Tab'] == 7) $Output .= $this->ExportViewOutput();
				else $Output .= $this->ExportViewGeneral();
	
				$Output .= '</div>';
			} else $Output .= ShowMessage('Export nenalezen.', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Nebylo zadáno Id.', MESSAGE_CRITICAL);
		return($Output);
	}
	
  function Show()
  {
    if(array_key_exists('Action', $_GET))
    {
      if($_GET['Action'] == 'Create') $Output = $this->ExportCreate();
      else if($_GET['Action'] == 'CreateFinish') $Output = $this->ExportCreateFinish();
      else if($_GET['Action'] == 'View') $Output = $this->ExportView();
      else if($_GET['Action'] == 'Delete') $Output = $this->ExportDelete();
      else $Output = $this->ExportList();
    } else $Output = $this->ExportList();
    return($Output);
  } 
}
